"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

TestCase subclass:#ClassReloadingTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tests-ClassReloading'
!

!ClassReloadingTests class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
!

history

    "Created: #registerChangingClassParent / 08-12-2012 / 18:37:52 / Marcel Hlopko <marcel.hlopko@fit.cvut.cz>"
! !

!ClassReloadingTests methodsFor:'test helpers'!

callFooMethodSource
    ^'
public int callFoo() {
    return 2;
}
'.

    "Created: / 08-12-2012 / 18:13:52 / Marcel Hlopko <marcel.hlopko@fit.cvut.cz>"
!

callerClass
    | callerClass |
    callerClass := JavaCompiler 
            compile: '
package classReloadingTests;
public class Caller {
    public int callFoo(ChangingClass c) {
        return c.foo();
    }   
}
'.
    callerClass 
        ifNil: [ self error: 'callerClass is expected to be not nil in these tests' ].
    ^ callerClass.

    "Created: / 06-12-2012 / 21:41:35 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 08-12-2012 / 18:34:33 / Marcel Hlopko <marcel.hlopko@fit.cvut.cz>"
!

changingClass
    | changingClass |
    self registerChangingClassParent.
    changingClass := JavaCompiler 
            compile: '
package classReloadingTests;
public class ChangingClass extends ChangingClassParent {}
'.
    changingClass 
        ifNil: [ self error: 'changingClass is expected to be not nil in these tests' ].
    ^ changingClass.

    "Created: / 06-12-2012 / 21:41:36 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 08-12-2012 / 18:38:35 / Marcel Hlopko <marcel.hlopko@fit.cvut.cz>"
!

changingClassWithAddedCallFooMethod
    | changingClass |
    self registerChangingClassParent.
    changingClass := JavaCompiler 
            compile: '
package classReloadingTests;
public class ChangingClass extends ChangingClassParent {
    public int foo() {
        return 2;
    }   
}
'.
    changingClass 
        ifNil: [ self error: 'changingClass is expected to be not nil in these tests' ].
    ^ changingClass.

    "Created: / 06-12-2012 / 21:41:39 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 08-12-2012 / 18:38:53 / Marcel Hlopko <marcel.hlopko@fit.cvut.cz>"
!

changingClassWithCallFooWithDifferentSignature
    | changingClass |
    self registerChangingClassParent.
    changingClass := JavaCompiler 
            compile: '
package classReloadingTests;
public class ChangingClass extends ChangingClassParent {
    public String foo() {
        return "different signature";
    }   
}
'.
    changingClass 
        ifNil: [ self error: 'changingClass is expected to be not nil in these tests' ].
    ^ changingClass.

    "Created: / 06-12-2012 / 21:50:02 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 08-12-2012 / 18:38:44 / Marcel Hlopko <marcel.hlopko@fit.cvut.cz>"
!

changingClassWithModifiedCallFooMethod
    | changingClass |
    self registerChangingClassParent.
    changingClass := JavaCompiler 
            compile: '
package classReloadingTests;
public class ChangingClass extends ChangingClassParent {
    public int foo() {
        return 2;
    }   
}
'.
    changingClass 
        ifNil: [ self error: 'changingClass is expected to be not nil in these tests' ].
    ^ changingClass.

    "Created: / 06-12-2012 / 21:49:19 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 08-12-2012 / 18:39:16 / Marcel Hlopko <marcel.hlopko@fit.cvut.cz>"
!

registerChangingClassParent
    | changingClassParent |
    changingClassParent := JavaCompiler 
            compile: '
package classReloadingTests;
public class ChangingClassParent {
    public int foo() {
        return 1;
    }   
}
'.
    changingClassParent 
        ifNil: [
            self error: 'changingClassParent is expected to be not nil in these tests'
        ].
    JavaVM registry registerClass: changingClassParent.

    "Created: / 08-12-2012 / 18:37:52 / Marcel Hlopko <marcel.hlopko@fit.cvut.cz>"
! !

!ClassReloadingTests class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
